import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ViewEncapsulation, Input, Output, NgModule } from '@angular/core';
import { FormBuilder, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ScAngularWysiwygService {
    constructor() {
        this.commands = [
            // cleanDoc: {
            //     isActive: false,
            //     title: 'Clean Doc',
            //     icon: 'fas fa-eraser',
            // },
            // TODO:: NOT WORKING
            // printDoc: {
            //     isActive: false,
            //     title: 'Print Doc',
            //     icon: 'fas fa-print',
            // },
            {
                command: 'undo',
                isActive: false,
                title: 'Undo',
                icon: 'fas fa-undo',
            },
            {
                command: 'redo',
                isActive: false,
                title: 'Redo',
                icon: 'fas fa-redo',
            },
            {
                command: 'removeFormat',
                isActive: false,
                title: 'Remove Formatting',
                icon: 'fas fa-remove-format',
            },
            {
                command: 'bold',
                isActive: false,
                title: 'Bold',
                icon: 'fas fa-bold',
            },
            {
                command: 'italic',
                isActive: false,
                title: 'Italic',
                icon: 'fas fa-italic',
            },
            {
                command: 'underline',
                isActive: false,
                title: 'Underline',
                icon: 'fas fa-underline',
            },
            {
                command: 'changeColor',
                isActive: false,
                title: 'Font Color',
                icon: 'fas fa-tint',
            },
            {
                command: 'justifyleft',
                isActive: false,
                title: 'Justify Left',
                icon: 'fas fa-align-left',
            },
            {
                command: 'justifycenter',
                isActive: false,
                title: 'Justify Center',
                icon: 'fas fa-align-justify',
            },
            {
                command: 'justifyright',
                isActive: false,
                title: 'Justify Right',
                icon: 'fas fa-align-right',
            },
            {
                command: 'insertorderedlist',
                isActive: false,
                title: 'Insert Ordered List',
                icon: 'fas fa-list-ol',
            },
            {
                command: 'insertunorderedlist',
                isActive: false,
                title: 'Insert Unordered List',
                icon: 'fas fa-list-ul',
            },
            // TODO:: NOT WORKING
            // blockquote: {
            //     isActive: false,
            //     title: 'Blockquote',
            //     icon: 'fas fa-quote-right',
            // },
            {
                command: 'outdent',
                isActive: false,
                title: 'Outdent',
                icon: 'fas fa-outdent',
            },
            {
                command: 'indent',
                isActive: false,
                title: 'Indent',
                icon: 'fas fa-indent',
            },
            {
                command: 'createLink',
                isActive: false,
                title: 'Link URL',
                icon: 'fas fa-link',
            },
            {
                command: 'cut',
                isActive: false,
                title: 'Cut',
                icon: 'fas fa-cut',
            },
            {
                command: 'copy',
                isActive: false,
                title: 'Copy',
                icon: 'fas fa-copy',
            },
            {
                command: 'getHtml',
                isActive: false,
                title: 'Get HTML',
                icon: '',
                text: 'HTML'
            },
        ];
        this.advanced = {
            backColor: {
                isActive: false,
                title: 'changeColor',
                icon: 'fas fa-paint-roller',
                values: {
                    red: "Red",
                    blue: "Blue",
                    green: "Green",
                    white: "White",
                    black: "Black"
                }
            },
            fontName: {
                isActive: false,
                title: 'Font',
                icon: 'fas fa-text',
                values: [
                    "Arial",
                    "Arial Black",
                    "Courier New",
                    "Times New Roman"
                ]
            },
            fontSize: {
                isActive: false,
                title: 'Font Size',
                icon: 'fas fa-text',
                values: {
                    1: "Tiny",
                    2: "Small",
                    3: "Normal",
                    4: "Medium",
                    5: "Large",
                    6: "Huge",
                    7: "Max"
                }
            },
            // TODO:: Set Up a color picker
            foreColor: {
                isActive: false,
                title: 'Font Color',
                icon: 'fas fa-text',
                values: {
                    red: "Red",
                    blue: "Blue",
                    green: "Green",
                    white: "White",
                    black: "Black"
                }
            },
            formatblock: {
                isActive: false,
                title: 'Font Color',
                icon: 'fas fa-text',
                values: {
                    h1: "Title 1",
                    h2: "Title 2",
                    h3: "Title 3",
                    h4: "Title 4",
                    h5: "Title 5",
                    h6: "Title 6",
                    p: "Paragraph",
                    pre: "Preformatted"
                }
            }
        };
    }
}
ScAngularWysiwygService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ScAngularWysiwygService.ctorParameters = () => [];
/** @nocollapse */ ScAngularWysiwygService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ScAngularWysiwygService_Factory() { return new ScAngularWysiwygService(); }, token: ScAngularWysiwygService, providedIn: "root" });
if (false) {
    /** @type {?} */
    ScAngularWysiwygService.prototype.commands;
    /** @type {?} */
    ScAngularWysiwygService.prototype.advanced;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ScAngularWysiwygComponent {
    /**
     * @param {?} _fb
     * @param {?} _editorService
     */
    constructor(_fb, _editorService) {
        this._fb = _fb;
        this._editorService = _editorService;
        /**
         * Allows for reading of the editors content
         */
        this.editorHtml = new EventEmitter();
        /**
         * editorConfig is the data thats used to build the forms
         */
        this.editorConfig = {};
        this.showHtml = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        console.log(this.commands, this.advanced);
        this.editorConfig.commands = this.commands || this._editorService.commands;
        this.editorConfig.advanced = this.advanced || this._editorService.advanced;
        this._createForms();
        this.htmlDisplay = document.querySelector(".sc-html-display");
        this.editorContent = document.querySelector(".sc-editor");
    }
    /**
     * @desc Executes the commands sent from the tool bar buttons
     * @param {?} commandId
     * @param {?} showUi
     * @param {?} value
     * @return {?}
     */
    executeCommand(commandId, showUi, value) {
        switch (commandId) {
            case "link":
                this.link();
                break;
            case "changeColor":
                this.changeColor();
                break;
            case "getHtml":
                this.showHtml = !this.showHtml;
                this.getHtml();
                break;
            default:
                document.execCommand(commandId, showUi, value);
                break;
        }
    }
    /**
     * @desc Prompts user to enter a link
     * @return {?}
     */
    link() {
        /** @type {?} */
        let url = prompt("Enter the URL");
        document.execCommand("createLink", false, url);
    }
    /**
     * @desc Changes the font color
     * @return {?}
     */
    changeColor() {
        /** @type {?} */
        let color = prompt("Enter Hex Code");
        document.execCommand("foreColor", false, color);
    }
    /**
     * @desc Displays the HTML of the editor content
     * @return {?}
     */
    getHtml() {
        /** @type {?} */
        let editorContent = this.editorContent.innerHTML;
        this.htmlDisplay.style.display = "block";
        this.htmlDisplay.textContent = editorContent;
        return editorContent;
    }
    /**
     * When keys are pressed, update the parents binding
     * @param {?} event
     * @return {?}
     */
    onKey(event) {
        this.editorHtml.emit(this.getHtml());
    }
    /**
     * @desc Create the more advanced forms
     * @return {?}
     */
    _createForms() {
        this.fontTypeForm = this._fb.group({
            fonttype: ['Arial']
        });
        this.fontTypeForm.controls['fonttype'].valueChanges.subscribe((/**
         * @param {?} value
         * @return {?}
         */
        value => {
            this.executeCommand('fontname', false, value);
        }));
        this.fontSizeForm = this._fb.group({
            fontsize: [4]
        });
        this.fontSizeForm.controls['fontsize'].valueChanges.subscribe((/**
         * @param {?} value
         * @return {?}
         */
        value => {
            this.executeCommand('fontsize', false, value);
        }));
        this.formatForm = this._fb.group({
            formatblock: ['p']
        });
        this.formatForm.controls['formatblock'].valueChanges.subscribe((/**
         * @param {?} value
         * @return {?}
         */
        value => {
            this.executeCommand('formatblock', false, value);
        }));
    }
}
ScAngularWysiwygComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-sc-angular-wysiwyg',
                template: "<div class=\"sc-container\">\r\n    <div class=\"sc-toolbar\">\r\n        <div>\r\n            <button \r\n                *ngFor=\"let command of editorConfig.commands\" \r\n                title=\"{{command.title}}\" \r\n                class=\"sc-tool-btn\" \r\n                (click)=\"executeCommand(command.command, false, '')\">\r\n                <i class=\"{{command.icon}}\"></i>\r\n                {{command.text ? command.text : ''}}\r\n            </button>\r\n        </div>\r\n\r\n        <div class=\"sc-form-group\">\r\n            <form class=\"sc-form\" [formGroup]=\"fontTypeForm\">\r\n                <select formControlName=\"fonttype\" id=\"fonttype\">\r\n                    <option *ngFor=\"let fontType of editorConfig.advanced.fontName.values\" [value]=\"fontType\">\r\n                        {{fontType}}\r\n                    </option>\r\n                </select>\r\n            </form>\r\n        \r\n            <form class=\"sc-form\" [formGroup]=\"fontSizeForm\">\r\n                <select formControlName=\"fontsize\" id=\"fontsize\">\r\n                    <option *ngFor=\"let fontSize of editorConfig.advanced.fontSize.values | keyvalue\" [value]=\"fontSize.key\">\r\n                        {{fontSize.value}}\r\n                    </option>\r\n                </select>\r\n            </form>\r\n        \r\n            <form class=\"sc-form\" [formGroup]=\"formatForm\">\r\n                <select formControlName=\"formatblock\" id=\"formatblock\">\r\n                    <option *ngFor=\"let format of editorConfig.advanced.formatblock.values | keyvalue\" [value]=\"format.key\">\r\n                        {{format.value}}\r\n                    </option>\r\n                </select>\r\n            </form>\r\n        </div>\r\n    </div>\r\n    \r\n    <div [hidden]=\"showHtml\" class=\"sc-editor\" contenteditable (keyup)=\"onKey($event)\">\r\n        <p> Get typing!!</p>\r\n    </div>\r\n\r\n    <section [hidden]=\"!showHtml\" class=\"sc-html-display\"></section>\r\n</div>\r\n",
                encapsulation: ViewEncapsulation.None,
                styles: [":root{--sc-toolbar-bg-color:#3F403F;--sc-toolbar-btn-color:#3F403F;--sc-toolbar-font-color:#E3E6E4;--sc-editor-bg-color:#E3E6E4;--sc-editor-font-color:#3F403F}.sc-container{display:inline-block}.sc-container .sc-toolbar{padding:5px;max-width:931px;background-color:var(--sc-toolbar-bg-color);display:inline-block}.sc-container .sc-toolbar .sc-tool-btn{min-width:40px;height:40px;font-size:18px;cursor:pointer;border:0;margin-right:10px;color:var(--sc-toolbar-font-color);background-color:var(--sc-toolbar-btn-color)}.sc-container .sc-toolbar .sc-form-group,.sc-container .sc-toolbar .sc-form-group .sc-form{display:inline-block}.sc-container .sc-toolbar .sc-form-group .sc-form select{height:30px;margin-right:5px}.sc-container .sc-editor,.sc-container .sc-html-display{padding:5px;color:var(--sc-editor-font-color);background-color:var(--sc-editor-bg-color);max-width:931px;box-sizing:border-box}"]
            }] }
];
/** @nocollapse */
ScAngularWysiwygComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: ScAngularWysiwygService }
];
ScAngularWysiwygComponent.propDecorators = {
    commands: [{ type: Input }],
    advanced: [{ type: Input }],
    editorHtml: [{ type: Output }]
};
if (false) {
    /**
     * Allows overriding of commands
     * Items will display in the order of the array
     * Please see reference doc for more info https://github.com/samc05991/sc-angular-wysiwyg
     * @type {?}
     */
    ScAngularWysiwygComponent.prototype.commands;
    /**
     * Allows overriding of advanced commands
     * @type {?}
     */
    ScAngularWysiwygComponent.prototype.advanced;
    /**
     * Allows for reading of the editors content
     * @type {?}
     */
    ScAngularWysiwygComponent.prototype.editorHtml;
    /**
     * The area the user is allowed to type into
     * @type {?}
     */
    ScAngularWysiwygComponent.prototype.editorContent;
    /**
     * editorConfig is the data thats used to build the forms
     * @type {?}
     */
    ScAngularWysiwygComponent.prototype.editorConfig;
    /**
     * each type of advanced form
     * @type {?}
     */
    ScAngularWysiwygComponent.prototype.fontTypeForm;
    /** @type {?} */
    ScAngularWysiwygComponent.prototype.fontSizeForm;
    /** @type {?} */
    ScAngularWysiwygComponent.prototype.formatForm;
    /**
     * Where the HTML will display
     * @type {?}
     */
    ScAngularWysiwygComponent.prototype.htmlDisplay;
    /** @type {?} */
    ScAngularWysiwygComponent.prototype.showHtml;
    /**
     * @type {?}
     * @private
     */
    ScAngularWysiwygComponent.prototype._fb;
    /**
     * @type {?}
     * @private
     */
    ScAngularWysiwygComponent.prototype._editorService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ScAngularWysiwygModule {
}
ScAngularWysiwygModule.decorators = [
    { type: NgModule, args: [{
                declarations: [ScAngularWysiwygComponent],
                imports: [
                    BrowserModule,
                    FormsModule, ReactiveFormsModule
                ],
                exports: [ScAngularWysiwygComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ScAngularWysiwygComponent, ScAngularWysiwygModule, ScAngularWysiwygService };
//# sourceMappingURL=sc-angular-wysiwyg.js.map
