import { EventEmitter, OnInit } from '@angular/core';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ScAngularWysiwygService } from './sc-angular-wysiwyg.service';
export declare class ScAngularWysiwygComponent implements OnInit {
    private _fb;
    private _editorService;
    /**
     * Allows overriding of commands
     * Items will display in the order of the array
     * Please see reference doc for more info https://github.com/samc05991/sc-angular-wysiwyg
     */
    commands?: [{}];
    /**
     * Allows overriding of advanced commands
     */
    advanced?: Object;
    /**
     * Allows for reading of the editors content
     */
    editorHtml: EventEmitter<string>;
    /**
     * The area the user is allowed to type into
     */
    editorContent: any;
    /**
     * editorConfig is the data thats used to build the forms
     */
    editorConfig: any;
    /**
     * each type of advanced form
     */
    fontTypeForm: FormGroup;
    fontSizeForm: FormGroup;
    formatForm: FormGroup;
    /**
     * Where the HTML will display
     */
    htmlDisplay: any;
    showHtml: boolean;
    constructor(_fb: FormBuilder, _editorService: ScAngularWysiwygService);
    ngOnInit(): void;
    /**
     * @desc Executes the commands sent from the tool bar buttons
     * @param commandId
     * @param showUi
     * @param value
     */
    executeCommand(commandId: string, showUi: boolean, value: any): void;
    /**
     * @desc Prompts user to enter a link
     */
    link(): void;
    /**
     * @desc Changes the font color
     */
    changeColor(): void;
    /**
     * @desc Displays the HTML of the editor content
     */
    getHtml(): any;
    /**
     * When keys are pressed, update the parents binding
     * @param event
     */
    onKey(event: any): void;
    /**
     * @desc Create the more advanced forms
     */
    _createForms(): void;
}
